#include "Bdef.h"

void vmcopy4(int m, int n, int *A, int lda, int *buff)
/*
 *  performs a 4 byte vector to matrix copy (unpack)
 */
{
   int i, j;
   long iaddr;

   iaddr = (long) A;

/*
 * If address is on a 8 byte boundary, and lda and m are evenly divisible by 2,
 * can use double sized pointers for faster packing
 */
   if ( !(iaddr % 8) && !(lda % 2) && !(m % 2) )
      vmcopy8(m/2, n, (double *) A, lda/2, (double *) buff);
/*
 * Otherwise, must use 4 byte packing
 */
   else
   {
      if ( (m == lda) || (n == 1) )
      {
         m = n * m;
         for (i=0; i < m; i++) A[i] = buff[i];
      }
      else if (m == 1)
      {
         for (j=0; j < n; j++) A[j*lda] = buff[j];
      }
      else
      {
         for (j=0; j < n; j++)
         {
            for (i=0; i < m; i++) A[i] = buff[i];
            A += lda;
            buff += m;
         }
      }
   }
}
